"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var __1 = require("..");
var getInitialValues = function (initializer) { return (new Promise(function (rs) {
    if (initializer instanceof Promise) {
        initializer.then(function (data) { return rs(data); });
    }
    else {
        rs(initializer);
    }
})); };
exports.Form = function (props) {
    var store = props.store;
    if (props.validate) {
        store.setupValidation(props.validate);
    }
    if (props.availability) {
        store.setupAvailability(props.availability);
    }
    var onSubmit = function (e) {
        e.preventDefault();
        store.submit();
    };
    getInitialValues(props.initialValues)
        .then(function (initialValues) {
        if (!isEqual_1.default(initialValues, store.initialValues)) {
            store.initialize(initialValues, function () {
                if (props.forceValidation) {
                    store.validate();
                }
            });
        }
        else {
            if (props.forceValidation) {
                store.validate();
            }
        }
        if (props.forceAvailability) {
            store.handleAvailability();
        }
        if (props.submit) {
            store.setupSubmit(props.submit);
        }
    });
    return (react_1.default.createElement(__1.FormContext.Provider, { value: props.store },
        react_1.default.createElement("form", { onSubmit: onSubmit }, props.children)));
};
