import { AvailabilityCallback, FieldProps, FieldValidator, Initializer, PossibleErrors, SubmitCallback, ValidateCallback } from "..";
export declare class FormStore<V> {
    submitting: boolean;
    validating: boolean;
    initializing: boolean;
    initializingError: Error;
    submitResult: string | object;
    submitError: string | object;
    errors: PossibleErrors<V>;
    disabledFields: boolean | { [key in keyof V]?: boolean; };
    valid: boolean;
    pristine: boolean;
    values: V;
    initialValues: V;
    private validators;
    private submitCallback;
    private validateCallback;
    private availabilityCallback;
    initialize(initializer: Initializer<V>, initializeCallback?: () => void): this;
    validate(): Promise<void>;
    submit(): void;
    setupSubmit(submitCallback: SubmitCallback<V>): this;
    setupValidation(validateCallback: ValidateCallback<V>): this;
    setupAvailability(availabilityCallback: AvailabilityCallback<V>): this;
    setupFieldValidator(name: string, validator: FieldValidator): this;
    handleChange: (name: string) => (value: any) => void;
    handleAvailability: () => void;
    reset(): this;
    getField(name: string): FieldProps;
    private resetValues;
}
export declare function createFormStore<V>(): FormStore<V>;
