"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var mobx_1 = require("mobx");
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var FormStore = /** @class */ (function () {
    function FormStore() {
        var _this = this;
        this.submitting = false;
        this.validating = false;
        this.initializing = false;
        this.initializingError = null;
        this.submitResult = null;
        this.submitError = null;
        this.errors = null;
        this.disabledFields = null;
        this.valid = false;
        this.pristine = false;
        this.values = {};
        this.initialValues = null;
        this.validators = {};
        this.submitCallback = null;
        this.validateCallback = null;
        this.availabilityCallback = null;
        this.handleChange = function (name) { return function (value) {
            if (!_this.submitting && !_this.validating) {
                _this.values[name] = value;
                _this.pristine = isEqual_1.default(_this.values, _this.initialValues);
                _this.validate();
                _this.handleAvailability();
            }
        }; };
        this.handleAvailability = function () {
            if (_this.availabilityCallback) {
                _this.disabledFields = _this.availabilityCallback(_this.values, _this.initialValues);
            }
        };
    }
    FormStore.prototype.initialize = function (initializer, initializeCallback) {
        var _this = this;
        this.pristine = true;
        this.validators = {};
        this.submitResult = null;
        if (initializer instanceof Promise) {
            this.initializing = true;
            initializer
                .then(function (result) {
                _this.initializing = false;
                _this.initialValues = result;
                _this.values = result;
                initializeCallback();
            })
                .catch(function (error) {
                _this.initializing = false;
                _this.initializingError = error;
            });
        }
        else {
            this.initialValues = initializer;
            this.values = initializer;
            if (typeof initializeCallback === "function") {
                initializeCallback();
            }
        }
        return this;
    };
    FormStore.prototype.validate = function () {
        return __awaiter(this, void 0, void 0, function () {
            var validation, mainErrors, _a, localErrors, names;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.validating = true;
                        validation = this.validateCallback ? this.validateCallback(this.values, this.initialValues) : null;
                        if (!(validation instanceof Promise)) return [3 /*break*/, 2];
                        return [4 /*yield*/, validation];
                    case 1:
                        _a = _b.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        _a = validation ? validation : {};
                        _b.label = 3;
                    case 3:
                        mainErrors = _a;
                        localErrors = {};
                        if (this.validators) {
                            names = Object.keys(this.validators);
                            names.map(function (key) {
                                var error = _this.validators[key](_this.values[key], key, _this.initialValues && _this.initialValues[key], _this.values, _this.initialValues);
                                if (error) {
                                    localErrors[key] = error;
                                }
                            });
                        }
                        this.valid = !Object.keys(mainErrors || {}).length && !Object.keys(localErrors || {}).length;
                        this.errors = this.valid
                            ? null
                            : __assign(__assign({}, (localErrors || {})), (mainErrors || {}));
                        this.validating = false;
                        return [2 /*return*/];
                }
            });
        });
    };
    FormStore.prototype.submit = function () {
        var _this = this;
        if (this.valid && this.submitCallback) {
            this.submitting = true;
            this.submitResult = null;
            this.submitError = null;
            var submitResult = this.submitCallback(this.values, this.initialValues);
            if (submitResult instanceof Promise) {
                submitResult
                    .then(function (result) {
                    if (_this.submitting) {
                        _this.submitting = false;
                        _this.submitResult = result;
                    }
                })
                    .catch(function (error) {
                    if (_this.submitting) {
                        _this.submitting = false;
                        _this.submitError = error.message;
                    }
                });
            }
            else {
                this.submitting = false;
                this.submitResult = submitResult;
            }
        }
    };
    FormStore.prototype.setupSubmit = function (submitCallback) {
        this.submitCallback = submitCallback;
        return this;
    };
    FormStore.prototype.setupValidation = function (validateCallback) {
        this.validateCallback = validateCallback;
        return this;
    };
    FormStore.prototype.setupAvailability = function (availabilityCallback) {
        this.availabilityCallback = availabilityCallback;
        return this;
    };
    FormStore.prototype.setupFieldValidator = function (name, validator) {
        this.validators[name] = validator;
        return this;
    };
    FormStore.prototype.reset = function () {
        this.resetValues();
        this.pristine = true;
        this.submitting = false;
        this.submitResult = null;
        return this;
    };
    FormStore.prototype.getField = function (name) {
        var tName = name;
        var value = this.values[tName];
        var initialValue = this.initialValues && this.initialValues[tName];
        var pristine = isEqual_1.default(value, initialValue);
        var touched = !pristine;
        var valid = this.errors ? !this.errors[tName] : true;
        var error = this.errors ? this.errors[tName] : null;
        var disabled = this.disabledFields !== null &&
            this.disabledFields !== true &&
            (this.disabledFields === false || this.disabledFields[tName]);
        return {
            pristine: pristine,
            value: value,
            initialValue: initialValue,
            touched: touched,
            valid: valid,
            error: error,
            disabled: disabled,
            name: name,
            values: this.values,
        };
    };
    FormStore.prototype.resetValues = function () {
        var _this = this;
        this.values = Object.keys(this.initialValues || {}).reduce(function (collect, key) {
            // @ts-ignore
            collect[key] = _this.initialValues[key];
            return collect;
        }, {});
    };
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "submitting", void 0);
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "validating", void 0);
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "initializing", void 0);
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "initializingError", void 0);
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "submitResult", void 0);
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "submitError", void 0);
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "errors", void 0);
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "disabledFields", void 0);
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "valid", void 0);
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "pristine", void 0);
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "values", void 0);
    __decorate([
        mobx_1.observable
    ], FormStore.prototype, "initialValues", void 0);
    __decorate([
        mobx_1.action
    ], FormStore.prototype, "initialize", null);
    __decorate([
        mobx_1.action
    ], FormStore.prototype, "validate", null);
    __decorate([
        mobx_1.action
    ], FormStore.prototype, "submit", null);
    __decorate([
        mobx_1.action
    ], FormStore.prototype, "setupSubmit", null);
    __decorate([
        mobx_1.action
    ], FormStore.prototype, "setupValidation", null);
    __decorate([
        mobx_1.action
    ], FormStore.prototype, "setupAvailability", null);
    __decorate([
        mobx_1.action
    ], FormStore.prototype, "setupFieldValidator", null);
    __decorate([
        mobx_1.action
    ], FormStore.prototype, "handleChange", void 0);
    __decorate([
        mobx_1.action
    ], FormStore.prototype, "handleAvailability", void 0);
    __decorate([
        mobx_1.action
    ], FormStore.prototype, "reset", null);
    return FormStore;
}());
exports.FormStore = FormStore;
function createFormStore() {
    return new FormStore();
}
exports.createFormStore = createFormStore;
